searchNodes=[{"doc":"Defines a queues machine.A Queuetopia can manage multiple ordered blocking queues. All the queues share only the same scheduler and the poll interval. They are completely independant from each other.A Queuetopia expects a performer to exist. For example, the performer can be implemented like this:defmodule MyApp.MailQueue.Performer do @behaviour Queuetopia.Jobs.Performer @impl true def perform(%Queuetopia.Jobs.Job{action: &quot;do_x&quot;}) do do_x() end defp do_x(), do: {:ok, &quot;done&quot;} endAnd the Queuetopia:defmodule MyApp.MailQueue do use Queuetopia, otp_app: :my_app, performer: MyApp.MailQueue.Performer, repo: MyApp.Repo end # config/config.exs config :my_app, MyApp.MailQueue, poll_interval: 60 * 1_000, repoll_after_job_performed?: true, disable?: true","ref":"Queuetopia.html","title":"Queuetopia","type":"behaviour"},{"doc":"Creates a job.Job optionsA job accepts the following options::timeout - The time in milliseconds to wait for the job to finish. (default: 60_000):max_backoff - default to 24 3600 1_000:max_attempts - default to 20.Examplesiex&gt; MyApp.MailQueue.create_job(&quot;mails_queue_1&quot;, &quot;send_mail&quot;, %{email_address: &quot;toto@mail.com&quot;, body: &quot;Welcome&quot;}, [timeout: 1_000, max_backoff: 60_000])","ref":"Queuetopia.html#c:create_job/4","title":"Queuetopia.create_job/4","type":"callback"},{"doc":"","ref":"Queuetopia.Jobs.html","title":"Queuetopia.Jobs","type":"module"},{"doc":"Creates a job, specifying the performer, the Queuetopia (scope), and the user params, including options.","ref":"Queuetopia.Jobs.html#create_job/7","title":"Queuetopia.Jobs.create_job/7","type":"function"},{"doc":"Returns true if a job is done. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#done?/1","title":"Queuetopia.Jobs.done?/1","type":"function"},{"doc":"Fetches a specific job. Acquires the lock on the queue and returns the job if it actually and reached it schedule time. In case of error, returns a tuple error.","ref":"Queuetopia.Jobs.html#fetch_job/2","title":"Queuetopia.Jobs.fetch_job/2","type":"function"},{"doc":"Get the next available pending job of a given queue by scope a.k.a by Queuetopia. If the queue is empty or the next pendign job is scheduled for later, returns nil.","ref":"Queuetopia.Jobs.html#get_next_pending_job/3","title":"Queuetopia.Jobs.get_next_pending_job/3","type":"function"},{"doc":"List the available pending queues by scope a.k.a by Queuetopia.","ref":"Queuetopia.Jobs.html#list_available_pending_queues/2","title":"Queuetopia.Jobs.list_available_pending_queues/2","type":"function"},{"doc":"Performs the job. Let the performer do its job.","ref":"Queuetopia.Jobs.html#perform/1","title":"Queuetopia.Jobs.perform/1","type":"function"},{"doc":"Persist in DB the result of job execution. Attempts fields are filled. In case of success, set the done_at field. Otherwise, save the error, prepare the job for a next retry, resetting the scheduled_at with the backoff calculation.","ref":"Queuetopia.Jobs.html#persist_result/3","title":"Queuetopia.Jobs.persist_result/3","type":"function"},{"doc":"Returns true if a job scheduled date is reached and the job is not done yet. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#processable_now?/1","title":"Queuetopia.Jobs.processable_now?/1","type":"function"},{"doc":"Returns true if a job scheduled date is reached. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#scheduled_for_now?/1","title":"Queuetopia.Jobs.scheduled_for_now?/1","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html","title":"Queuetopia.Jobs.Job","type":"module"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#create_changeset/1","title":"Queuetopia.Jobs.Job.create_changeset/1","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_max_attempts/0","title":"Queuetopia.Jobs.Job.default_max_attempts/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_max_backoff/0","title":"Queuetopia.Jobs.Job.default_max_backoff/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_timeout/0","title":"Queuetopia.Jobs.Job.default_timeout/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#failed_job_changeset/2","title":"Queuetopia.Jobs.Job.failed_job_changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#succeeded_job_changeset/2","title":"Queuetopia.Jobs.Job.succeeded_job_changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#t:option/0","title":"Queuetopia.Jobs.Job.option/0","type":"type"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#t:t/0","title":"Queuetopia.Jobs.Job.t/0","type":"type"},{"doc":"The behaviour for a Queuetopia performer.","ref":"Queuetopia.Jobs.Performer.html","title":"Queuetopia.Jobs.Performer","type":"behaviour"},{"doc":"Callback invoked by the Queuetopia to perfom a job. It may return :ok, an :ok tuple or a tuple error, with a string as error. Note that any failure in the processing will cause the job to be retried.","ref":"Queuetopia.Jobs.Performer.html#c:perform/1","title":"Queuetopia.Jobs.Performer.perform/1","type":"callback"},{"doc":"","ref":"Queuetopia.Locks.html","title":"Queuetopia.Locks","type":"module"},{"doc":"","ref":"Queuetopia.Locks.html#lock_queue/4","title":"Queuetopia.Locks.lock_queue/4","type":"function"},{"doc":"","ref":"Queuetopia.Locks.html#release_expired_locks/2","title":"Queuetopia.Locks.release_expired_locks/2","type":"function"},{"doc":"","ref":"Queuetopia.Locks.html#unlock_queue/3","title":"Queuetopia.Locks.unlock_queue/3","type":"function"},{"doc":"","ref":"Queuetopia.Locks.Lock.html","title":"Queuetopia.Locks.Lock","type":"module"},{"doc":"","ref":"Queuetopia.Locks.Lock.html#changeset/2","title":"Queuetopia.Locks.Lock.changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Locks.Lock.html#t:t/0","title":"Queuetopia.Locks.Lock.t/0","type":"type"},{"doc":"The Queuetopia scheduler, polling with a defined interval the next available queues.","ref":"Queuetopia.Scheduler.html","title":"Queuetopia.Scheduler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Queuetopia.Scheduler.html#child_spec/1","title":"Queuetopia.Scheduler.child_spec/1","type":"function"},{"doc":"","ref":"Queuetopia.Scheduler.html#send_poll/1","title":"Queuetopia.Scheduler.send_poll/1","type":"function"},{"doc":"","ref":"Queuetopia.Scheduler.html#start_link/1","title":"Queuetopia.Scheduler.start_link/1","type":"function"},{"doc":"","ref":"Queuetopia.Scheduler.html#t:option/0","title":"Queuetopia.Scheduler.option/0","type":"type"},{"doc":"","ref":"Queuetopia.Test.Assertions.html","title":"Queuetopia.Test.Assertions","type":"module"},{"doc":"Asserts the job has juste been created","ref":"Queuetopia.Test.Assertions.html#assert_job_created/2","title":"Queuetopia.Test.Assertions.assert_job_created/2","type":"function"},{"doc":"Queuetopia A persistant blocking job queue built with Ecto.FeaturesPersistence — Jobs are stored in a DB and updated after each execution attempt.Blocking — A failing job blocks its queue until it is done.Dynamicity — Queues are dynamically defined. Once the first job is created for the queue, the queue exists.Reactivity — Immediatly try to execute a job that has just been created.Retries — Failed jobs are retried with a configurable backoff.Persistence — Jobs are stored in a DB and updated after each execution attempt.Performance — At each poll, only one job per queue is run. Optionnaly, jobs can avoid waiting unnecessarily. The performed job triggers an other polling.Isolated Queues — Jobs are stored in a single table but are executed in distinct queues. Each queue runs in isolation, ensuring that a job in a single slow queue can't back up other faster queues and that a failing job in a queue don't block other queues.Handle Node Duplication — Queues are locked, preventing two nodes to perform the same job at the same time.","ref":"readme.html","title":"Queuetopia","type":"extras"},{"doc":"Queuetopia is published on Hex. The package can be installed by adding queuetopia to your list of dependencies in mix.exs:def deps do [ {:queuetopia, &quot;~&gt; 1.0.0&quot;} ] endAfter the packages are installed you must create a database migration to add the queuetopia tables to your database:mix ecto.gen.migration create_queuetopia_tablesOpen the generated migration in your editor and call the up and down functions on Queuetopia.Migrations:defmodule MyApp.Repo.Migrations.CreateQueuetopiaTables do use Ecto.Migration def up do Queuetopia.Migrations.V1.up end def down do Queuetopia.Migrations.V1.down end endNow, run the migration to create the table:mix ecto.migrate","ref":"readme.html#installation","title":"Queuetopia - Installation","type":"extras"},{"doc":"Defining the QueuetopiaA Queuetopia must be informed a repo to persist the jobs and a performer module, responsible to execute the jobs.Define a Queuetopia with a repo and a perfomer like this:defmodule MyApp.MailQueue do use Queuetopia, repo: MyApp.Repo, performer: MyApp.MailQueue.Performer endDefine the perfomer, adopting the Queuetopia.Jobs.Performer behaviour, like this:defmodule MyApp.MailQueue.Performer do @behaviour Queuetopia.Jobs.Performer @impl true def perform(%Queuetopia.Jobs.Job{action: &quot;do_x&quot;}) do do_x() end defp do_x(), do: {:ok, &quot;done&quot;} endStart the QueuetopiaAn instance Queuetopia is a supervision tree and can be started as a child of a supervisor.For instance, in the application supervision tree:defmodule MyApp do use Application def start(_type, _args) do children = [ MyApp.MailQueue ] Supervisor.start_link(children, strategy: :one_for_one) end endOr, it can be started directly like this:MyApp.MailQueue.start_link()The configuration can be set as below: # config/config.exs config :my_app, MyApp.MailQueue, poll_interval: 60 * 1_000, repoll_after_job_performed?: true, disable?: true Note that the polling interval is optionnal. By default, it will be set to 60 seconds.Feeds your queuesTo create a job defines its action and its params and configure its timeout and the max backoff for the retries. By default, the job timeout is set to 60 seconds, the max backoff to 24 hours and the max attempts to 20.MyApp.MailQueue.create_job(&quot;mails_queue_1&quot;, &quot;send_mail&quot;, %{email_address: &quot;toto@mail.com&quot;, body: &quot;Welcome&quot;}, [timeout: 1_000, max_backoff: 60_000])So, the mails_queue_1 was born and you can add it other jobs as we do above.You can wake up the scheduler to run the next pending jobs by calling the send_poll/0 function.MyApp.MailQueue.send_poll()One DB, many QueuetopiaMultiple Queuetopia can coexist in your project, e.g your project may own its Queuetopia and uses a library shipping its Queuetopia. The both Queuetopia may run on the same DB and share the same repo. They will have a different scheduler, may have a different polling interval. They will be defined a scope to reach only their own jobs, so the won't interfer each other.","ref":"readme.html#usage","title":"Queuetopia - Usage","type":"extras"},{"doc":"Rename env/test.env.example to env/test.env, set your params and source it.MIX_ENV=test mix do ecto.drop, ecto.create, ecto.migrate mix testDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/queuetopia.Thanks to [Oban] [https://github.com/sorentwo/oban] and elixir community who inspired the Queuetopia development.","ref":"readme.html#test","title":"Queuetopia - Test","type":"extras"}]